package nc.api.jitu.res;

package ..deTemp.1732551204316;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.google.common.collect.Maps;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Map;
import javax.ws.rs.Consumes;
import javax.ws.rs.POST;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import nc.api.jitu.res.util.LogUtil;
import nc.api.jitu.res.vo.LogVO;
import nc.bs.framework.common.NCLocator;
import nc.bs.pub.pf.PfUtilTools;
import nc.bs.trade.business.HYPubBO;
import nc.itf.ic.m4455.self.ISapplyBillMaintain;
import nc.itf.ic.m4455.self.ISapplyBillQuery;
import nc.itf.ic.m4d.IMaterialOutMaintain;
import nc.itf.uap.IUAPQueryBS;
import nc.jdbc.framework.processor.BeanProcessor;
import nc.jdbc.framework.processor.MapProcessor;
import nc.jdbc.framework.processor.ResultSetProcessor;
import nc.tools.Toolkits;
import nc.vo.bd.defdoc.DefdocVO;
import nc.vo.bd.material.MaterialVO;
import nc.vo.bd.material.MaterialVersionVO;
import nc.vo.bd.stordoc.StordocVO;
import nc.vo.ic.m4455.entity.SapplyBillBodyVO;
import nc.vo.ic.m4455.entity.SapplyBillHeadVO;
import nc.vo.ic.m4455.entity.SapplyBillVO;
import nc.vo.ic.m4d.entity.MaterialOutBodyVO;
import nc.vo.ic.m4d.entity.MaterialOutVO;
import nc.vo.org.DeptVO;
import nc.vo.org.StockOrgVO;
import nc.vo.pub.AggregatedValueObject;
import nc.vo.pub.BusinessException;
import nc.vo.pub.CircularlyAccessibleValueObject;
import nc.vo.pub.billtype.BilltypeVO;
import nc.vo.pub.lang.UFBoolean;
import nc.vo.pub.lang.UFDate;
import nc.vo.pub.lang.UFDouble;
import nc.vo.vorg.DeptVersionVO;
import nc.vo.vorg.StockOrgVersionVO;
import nccloud.api.rest.utils.ResultMessageUtil;
import nccloud.pub.jtreport.BaseDaoUtil;
import nccloud.ws.rest.resource.AbstractNCCRestResource;
import org.apache.commons.lang.exception.ExceptionUtils;
import org.json.JSONString;

@Path("jitu/jms/jmsOutRequisition")
public class ReceiveOutRequInvoiceResources extends AbstractNCCRestResource {
  IUAPQueryBS iqbs = (IUAPQueryBS)NCLocator.getInstance().lookup(IUAPQueryBS.class);
  
  HYPubBO hyPubBO = new HYPubBO();
  
  public String getModule() {
    return "jitu";
  }
  
  @POST
  @Path("/insert")
  @Consumes({"application/json"})
  @Produces({"application/json"})
  public JSONString jmsOutRequisition(JSONString json) {
    LogVO logVO = new LogVO();
    UFBoolean flag = UFBoolean.TRUE;
    JSONObject jObject = JSON.parseObject(json.toJSONString());
    if (jObject == null)
      return ResultMessageUtil.exceptionToJSON(new NullPointerException("JSONString:null")); 
    JSONObject headJsonObject = jObject.getJSONObject("ic_sapply_h");
    JSONArray bodysJsonObject = jObject.getJSONArray("ic_sapply_b");
    Map<String, String> resultMap = Maps.newHashMap();
    try {
      try {
        SapplyBillHeadVO sapplyBillHeadVO = new SapplyBillHeadVO();
        String dbilldate = headJsonObject.getString("dbilldate");
        String pk_org = headJsonObject.getString("pk_org");
        String ctrantypeid = headJsonObject.getString("vtrantypecode");
        String cdptid = headJsonObject.getString("cdptid");
        String vdef1 = headJsonObject.getString("vdef1");
        String vdef7 = headJsonObject.getString("vdef7");
        String vdef8 = headJsonObject.getString("vdef8");
        String vdef9 = headJsonObject.getString("vdef9");
        String cissueorg = headJsonObject.getString("cissueorg");
        if (!isLegalDate(dbilldate, "yyyy-MM-dd HH:mm:ss"))
          throw new BusinessException("申请时间格式不对或申请时间为空"); 
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        sapplyBillHeadVO.setDbilldate(new UFDate(sdf.parse(dbilldate)));
        String orgSql = "select * from org_stockorg where code='" + pk_org + "' and dr=0 AND ENABLESTATE=2";
        StockOrgVO kcOrgVO = (StockOrgVO)this.iqbs.executeQuery(orgSql, (ResultSetProcessor)new BeanProcessor(StockOrgVO.class));
        if (kcOrgVO == null)
          throw new BusinessException("编码为" + pk_org + "库存组织不存在"); 
        String orgvSql = "select * from org_stockorg_v where code='" + pk_org + "' and dr=0 AND ENABLESTATE=2";
        StockOrgVersionVO kcvOrgVO = (StockOrgVersionVO)this.iqbs.executeQuery(orgvSql, (ResultSetProcessor)new BeanProcessor(StockOrgVersionVO.class));
        if (kcvOrgVO == null)
          throw new BusinessException("编码为" + pk_org + "库存组织不存在"); 
        String billTypeSql = "select * from bd_billtype where pk_billtypecode='" + ctrantypeid + "'";
        BilltypeVO billTypeVO = (BilltypeVO)this.iqbs.executeQuery(billTypeSql, (ResultSetProcessor)new BeanProcessor(BilltypeVO.class));
        if (billTypeVO == null)
          throw new BusinessException("编码为" + ctrantypeid + "申请类型不存在"); 
        String ctpdSql = "select a.* from org_dept a left join org_orgs b on a.pk_org=b.pk_org where a.code='" + cdptid + "' and b.code='" + pk_org + "' and a.dr=0 AND A.ENABLESTATE=2";
        DeptVO deptVO = (DeptVO)this.iqbs.executeQuery(ctpdSql, (ResultSetProcessor)new BeanProcessor(DeptVO.class));
        if (deptVO == null)
          throw new BusinessException("编码为" + cdptid + "部门不存在"); 
        String ctpdvSql = "select a.* from org_dept_v a left join org_orgs b on a.pk_org=b.pk_org where a.code='" + cdptid + "' and b.code='" + pk_org + "' and a.dr=0  AND A.ENABLESTATE=2";
        DeptVersionVO deptvVO = (DeptVersionVO)this.iqbs.executeQuery(ctpdvSql, (ResultSetProcessor)new BeanProcessor(DeptVersionVO.class));
        if (deptvVO == null)
          throw new BusinessException("编码为" + cdptid + "部门不存在"); 
        String cissueSql = "select * from org_stockorg where code='" + cissueorg + "' and dr=0 AND ENABLESTATE=2";
        StockOrgVO stockOrgVO = (StockOrgVO)this.iqbs.executeQuery(cissueSql, (ResultSetProcessor)new BeanProcessor(StockOrgVO.class));
        if (stockOrgVO == null)
          throw new BusinessException("编码为" + cissueorg + "发料库存组织不存在"); 
        String cissuevSql = "select * from org_stockorg_v where code='" + cissueorg + "' and dr=0 AND ENABLESTATE=2";
        StockOrgVersionVO stockvOrgVO = (StockOrgVersionVO)this.iqbs.executeQuery(cissuevSql, (ResultSetProcessor)new BeanProcessor(StockOrgVersionVO.class));
        if (stockvOrgVO == null)
          throw new BusinessException("编码为" + cissueorg + "发料库存组织不存在"); 
        String oldStord = String.valueOf(vdef9) + "-02";
        String newStord = String.valueOf(vdef9) + "-01";
        String zyoSqlString = "select * from bd_stordoc where code='" + oldStord + "' and dr=0 AND ENABLESTATE=2";
        String zynSqlString = "select * from bd_stordoc where code='" + newStord + "' and dr=0 AND ENABLESTATE=2";
        StordocVO ostordocVO = (StordocVO)this.iqbs.executeQuery(zyoSqlString, (ResultSetProcessor)new BeanProcessor(StordocVO.class));
        StordocVO nstordocVO = (StordocVO)this.iqbs.executeQuery(zynSqlString, (ResultSetProcessor)new BeanProcessor(StordocVO.class));
        if (nstordocVO == null && ostordocVO == null)
          throw new BusinessException("转运编码为" + nstordocVO + "的仓库不存在"); 
        String cbSql = "SELECT A.* FROM BD_DEFDOC A LEFT JOIN BD_DEFDOCLIST B ON B.PK_DEFDOCLIST=A.PK_DEFDOCLIST WHERE B.CODE='CBZX' AND A.CODE='" + vdef1 + "' and A.dr=0 AND A.ENABLESTATE=2";
        DefdocVO defdocVO = (DefdocVO)this.iqbs.executeQuery(cbSql, (ResultSetProcessor)new BeanProcessor(DefdocVO.class));
        if (defdocVO == null)
          throw new BusinessException("编码为" + vdef1 + "成本中心不存在"); 
        if (vdef7 == null)
          throw new BusinessException("EAM申请人为空"); 
        if (vdef8 == null)
          throw new BusinessException("EAM申请单号为空"); 
        String jmsNumSql = "select * from ic_sapply_h where vdef8='" + vdef8 + "' and dr=0";
        SapplyBillHeadVO jmsVO = (SapplyBillHeadVO)this.iqbs.executeQuery(jmsNumSql, (ResultSetProcessor)new BeanProcessor(SapplyBillHeadVO.class));
        if (jmsVO != null)
          throw new BusinessException("EAM申请单号已经存在，EAM申请单号不能重复"); 
        sapplyBillHeadVO.setPk_org(kcOrgVO.getPk_stockorg());
        sapplyBillHeadVO.setPk_org_v(kcOrgVO.getPk_vid());
        sapplyBillHeadVO.SetCissueorg(stockOrgVO.getPk_stockorg());
        sapplyBillHeadVO.SetCissueorg_v(stockvOrgVO.getPk_vid());
        sapplyBillHeadVO.setCtrantypeid(billTypeVO.getPk_billtypeid());
        sapplyBillHeadVO.setVtrantypecode(billTypeVO.getPk_billtypecode());
        sapplyBillHeadVO.setCdptid(deptVO.getPk_dept());
        sapplyBillHeadVO.setCdptvid(deptvVO.getPk_vid());
        sapplyBillHeadVO.setVdef15(deptVO.getDef6());
        sapplyBillHeadVO.setFbillflag(Integer.valueOf(2));
        sapplyBillHeadVO.setVdef1(defdocVO.getPk_defdoc());
        sapplyBillHeadVO.setVdef7(vdef7);
        sapplyBillHeadVO.setVdef8(vdef8);
        sapplyBillHeadVO.setVdef9(vdef9);
        SapplyBillBodyVO[] sapplyBillBodyVOs = new SapplyBillBodyVO[bodysJsonObject.size()];
        for (int i = 0; i < bodysJsonObject.size(); i++) {
          JSONObject bodyJsonObject = bodysJsonObject.getJSONObject(i);
          SapplyBillBodyVO sapplyBillBodyVO = new SapplyBillBodyVO();
          sapplyBillBodyVO.setCrowno((new StringBuilder(String.valueOf(10 * (i + 1)))).toString());
          String materSql = "select * from bd_material where code='" + bodyJsonObject.getString("cmaterialvid") + "' and dr=0 AND ENABLESTATE=2";
          MaterialVO materialVO = (MaterialVO)this.iqbs.executeQuery(materSql, (ResultSetProcessor)new BeanProcessor(MaterialVO.class));
          if (materialVO == null)
            throw new BusinessException("编码为" + bodyJsonObject.getString("cmaterialvid") + "物料不存在"); 
          String matervSql = "select * from bd_material_v where code='" + bodyJsonObject.getString("cmaterialvid") + "' and dr=0 AND ENABLESTATE=2";
          MaterialVersionVO materialvVO = (MaterialVersionVO)this.iqbs.executeQuery(matervSql, (ResultSetProcessor)new BeanProcessor(MaterialVersionVO.class));
          if (materialvVO == null)
            throw new BusinessException("编码为" + bodyJsonObject.getString("cmaterialvid") + "物料不存在"); 
          if ("".equals(bodyJsonObject.getDouble("nassistnum").toString()) || bodyJsonObject.getDouble("nassistnum") == null)
            throw new BusinessException("申请数量不能为空"); 
          String vbdef1 = bodyJsonObject.getString("vbdef1");
          String jmsBodySql = "select * from ic_sapply_b where vbdef1='" + vbdef1 + "' and  dr=0";
          SapplyBillBodyVO jmsBodyVO = (SapplyBillBodyVO)this.iqbs.executeQuery(jmsBodySql, (ResultSetProcessor)new BeanProcessor(SapplyBillBodyVO.class));
          if (jmsBodyVO != null)
            throw new BusinessException("EAM行主键不能重复"); 
          String vbdef2 = bodyJsonObject.getString("vbdef2");
          String wbSql = "SELECT DEF.* FROM BD_DEFDOC DEF LEFT JOIN BD_DEFDOCLIST LIST ON DEF.PK_DEFDOCLIST=LIST.PK_DEFDOCLIST WHERE LIST.CODE='WBLX' AND DEF.CODE='" + vbdef2 + "' AND DEF.DR=0 ";
          DefdocVO wbVO = (DefdocVO)this.iqbs.executeQuery(wbSql, (ResultSetProcessor)new BeanProcessor(DefdocVO.class));
          if (wbVO == null)
            throw new BusinessException("编码为" + vbdef2 + "维保类型不能转换，请确认维保类型编码正确"); 
          String vchangerate = bodyJsonObject.getString("vchangerate");
          if ("".equals(vchangerate) || vchangerate == null)
            throw new BusinessException("换算率不能为空"); 
          sapplyBillBodyVO.setVbdef2(wbVO.getPk_defdoc());
          sapplyBillBodyVO.setVbdef1(vbdef1);
          sapplyBillBodyVO.setCmaterialvid(materialVO.getPk_material());
          sapplyBillBodyVO.setCmaterialoid(materialvVO.getPk_material());
          sapplyBillBodyVO.setCunitid(materialVO.getPk_measdoc());
          sapplyBillBodyVO.setCastunitid(materialVO.getPk_measdoc());
          sapplyBillBodyVO.setVchangerate(vchangerate);
          sapplyBillBodyVO.setVbatchcode(bodyJsonObject.getString("vbatchcode"));
          sapplyBillBodyVO.setNnum(new UFDouble(bodyJsonObject.getDouble("nassistnum")));
          sapplyBillBodyVO.setNassistnum(new UFDouble(bodyJsonObject.getDouble("nassistnum")));
          sapplyBillBodyVOs[i] = sapplyBillBodyVO;
        } 
        SapplyBillVO sapplyBillVO = new SapplyBillVO();
        sapplyBillVO.setParentVO((CircularlyAccessibleValueObject)sapplyBillHeadVO);
        sapplyBillVO.setChildrenVO((CircularlyAccessibleValueObject[])sapplyBillBodyVOs);
        ISapplyBillMaintain isa = (ISapplyBillMaintain)NCLocator.getInstance().lookup(ISapplyBillMaintain.class);
        SapplyBillVO[] resVO = isa.insert(new SapplyBillVO[] { sapplyBillVO });
        ISapplyBillQuery isaq = (ISapplyBillQuery)NCLocator.getInstance().lookup(ISapplyBillQuery.class);
        SapplyBillHeadVO resHeadVO = (SapplyBillHeadVO)resVO[0].getParentVO();
        String querySapplySql = "  from ic_sapply_h ic_sapply_h where ic_sapply_h.cgeneralhid='" + resHeadVO.getCgeneralhid() + "'";
        SapplyBillVO[] listSapp = isaq.querySapplyBill(querySapplySql);
        SapplyBillVO aggvo = listSapp[0];
        BaseDaoUtil.ipf.processAction("SAVE", aggvo.getHead().getVtrantypecode(), null, (AggregatedValueObject)aggvo, null, null);
        SapplyBillVO sBillVO = isaq.querySapplyBill(querySapplySql)[0];
        MaterialOutVO oldMaterialOutVO = (MaterialOutVO)PfUtilTools.runChangeData("4455", "4D", (AggregatedValueObject)sBillVO);
        MaterialOutVO newMaterialOutVO = (MaterialOutVO)oldMaterialOutVO.clone();
        MaterialOutBodyVO[] oldMaBodyVOs = oldMaterialOutVO.getBodys();
        MaterialOutBodyVO[] newMaBodyVOs = newMaterialOutVO.getBodys();
        ArrayList<MaterialOutBodyVO> resOldMaOut = new ArrayList<>();
        ArrayList<MaterialOutBodyVO> resNewMaOut = new ArrayList<>();
        String old_pk_stordoc = "";
        String new_pk_stordoc = "";
        Boolean isCreateNewflag = Boolean.valueOf(false);
        Boolean isCreateOldflag = Boolean.valueOf(false);
        for (int j = 0; j < oldMaBodyVOs.length; j++) {
          MaterialOutBodyVO oldOutBodyVO = oldMaBodyVOs[j];
          MaterialOutBodyVO newOutBodyVO = newMaBodyVOs[j];
          SapplyBillBodyVO bodyVO = listSapp[0].getBodys()[j];
          String numOldSql = "select ion.nonhandnum nonhandnum,iod.cmaterialvid cmaterialvid,bs.pk_stordoc pk_stordoc FROM ic_onhanddim iod INNER JOIN ic_onhandnum ion ON ion.pk_onhanddim = iod.pk_onhanddim INNER JOIN bd_stordoc bs ON bs.pk_stordoc = iod.cwarehouseid where iod.cmaterialvid='" + 

            
            bodyVO.getCmaterialoid() + "' and bs.code='" + oldStord + "' and iod.pk_org='" + bodyVO.getPk_org() + "'";
          Map<String, Object> resMap = (Map<String, Object>)this.iqbs.executeQuery(numOldSql, (ResultSetProcessor)new MapProcessor());
          UFDouble oldStrodNumDouble = new UFDouble(0.0D);
          UFDouble syDouble = new UFDouble(bodyVO.getNassistnum());
          Boolean newFlag = Boolean.valueOf(true);
          if (resMap != null) {
            if (!Toolkits.isEmpty(resMap.get("pk_stordoc")))
              old_pk_stordoc = resMap.get("pk_stordoc").toString(); 
            if (!Toolkits.isEmpty(resMap.get("nonhandnum"))) {
              UFDouble oldck = new UFDouble(Double.parseDouble(resMap.get("nonhandnum").toString()));
              UFDouble nassDouble = bodyVO.getNassistnum();
              if (oldck.compareTo(nassDouble) == -1) {
                oldStrodNumDouble = oldck;
                syDouble = nassDouble.sub(oldck);
              } else if (oldck.compareTo(nassDouble) != -1) {
                oldStrodNumDouble = nassDouble;
                syDouble = new UFDouble(0.0D);
                newFlag = Boolean.valueOf(false);
              } 
              if (oldck.compareTo(new UFDouble(0.0D)) != 0 && oldStrodNumDouble.compareTo(new UFDouble(0.0D)) != 0) {
                oldOutBodyVO.setNshouldassistnum(oldStrodNumDouble);
                oldOutBodyVO.setNshouldnum(oldStrodNumDouble);
                isCreateOldflag = Boolean.valueOf(true);
                resOldMaOut.add(oldOutBodyVO);
              } 
            } 
          } 
          if (newFlag.booleanValue()) {
            String numNewSql = "select ion.nonhandnum,iod.cmaterialvid,bs.pk_stordoc FROM ic_onhanddim iod INNER JOIN ic_onhandnum ion ON ion.pk_onhanddim = iod.pk_onhanddim INNER JOIN bd_stordoc bs ON bs.pk_stordoc = iod.cwarehouseid where iod.cmaterialvid='" + 

              
              bodyVO.getCmaterialoid() + "' and bs.code='" + newStord + "' and iod.pk_org='" + bodyVO.getPk_org() + "'";
            Map<String, Object> newResMap = (Map<String, Object>)this.iqbs.executeQuery(numNewSql, (ResultSetProcessor)new MapProcessor());
            UFDouble newStrodNumDouble = new UFDouble(0.0D);
            if (newResMap != null) {
              if (!Toolkits.isEmpty(newResMap.get("pk_stordoc")))
                new_pk_stordoc = newResMap.get("pk_stordoc").toString(); 
              if (!Toolkits.isEmpty(newResMap.get("nonhandnum"))) {
                UFDouble newck = new UFDouble(Double.parseDouble(newResMap.get("nonhandnum").toString()));
                if (newck.compareTo(syDouble) == -1) {
                  newStrodNumDouble = newck;
                } else {
                  newStrodNumDouble = syDouble;
                } 
                if (newck.compareTo(new UFDouble(0.0D)) != 0 && newStrodNumDouble.compareTo(new UFDouble(0.0D)) != 0) {
                  newOutBodyVO.setNshouldassistnum(newStrodNumDouble);
                  newOutBodyVO.setNshouldnum(newStrodNumDouble);
                  isCreateNewflag = Boolean.valueOf(true);
                  resNewMaOut.add(newOutBodyVO);
                } 
              } 
            } 
          } 
        } 
        oldMaterialOutVO.getHead().setCwarehouseid(old_pk_stordoc);
        oldMaterialOutVO.getHead().setDbilldate(sBillVO.getHead().getDbilldate());
        newMaterialOutVO.getHead().setCwarehouseid(new_pk_stordoc);
        newMaterialOutVO.getHead().setDbilldate(sBillVO.getHead().getDbilldate());
        oldMaterialOutVO.setChildrenVO((CircularlyAccessibleValueObject[])resOldMaOut.toArray((Object[])new MaterialOutBodyVO[resOldMaOut.size()]));
        newMaterialOutVO.setChildrenVO((CircularlyAccessibleValueObject[])resNewMaOut.toArray((Object[])new MaterialOutBodyVO[resNewMaOut.size()]));
        IMaterialOutMaintain materialMain = (IMaterialOutMaintain)NCLocator.getInstance().lookup(IMaterialOutMaintain.class);
        if (isCreateNewflag.booleanValue() && isCreateOldflag.booleanValue()) {
          materialMain.insert(new MaterialOutVO[] { oldMaterialOutVO, newMaterialOutVO });
        } else if (isCreateNewflag.booleanValue() && !isCreateOldflag.booleanValue()) {
          materialMain.insert(new MaterialOutVO[] { newMaterialOutVO });
        } else if (!isCreateNewflag.booleanValue() && isCreateOldflag.booleanValue()) {
          materialMain.insert(new MaterialOutVO[] { oldMaterialOutVO });
        } 
        String vbillcode = aggvo.getHead().getVbillcode();
        resultMap.put("message", "出库申请单保存成功");
        resultMap.put("code", "1");
        resultMap.put("success", "true");
        resultMap.put("data", vbillcode.toString());
        String resMsgString = resultMap.toString();
        logVO.setReturnmsg(resMsgString);
      } catch (Exception e) {
        throw new BusinessException(e.getMessage());
      } 
    } catch (Exception e) {
      System.out.print(e);
      flag = UFBoolean.FALSE;
      logVO.setErrormsg(ExceptionUtils.getStackTrace(e));
      resultMap.put("message", "出库申请单保存失败，原因：" + e);
      resultMap.put("code", "-1");
      resultMap.put("success", "false");
      resultMap.put("data", null);
      return ResultMessageUtil.toJSON(resultMap);
    } finally {
      logVO.setItftype("EAM出库申请单接口");
      logVO.setIssuccess(flag);
      logVO.setCaller("EAM");
      logVO.setReceiver("NCC");
      logVO.setInputmsg(json.toString());
      LogUtil.save(logVO);
    } 
    return ResultMessageUtil.toJSON(resultMap);
  }
  
  public boolean isLegalDate(String sDate, String format) {
    if (sDate == null)
      return false; 
    if (sDate.length() == 0)
      return false; 
    SimpleDateFormat formatter = new SimpleDateFormat(format);
    try {
      Date date = formatter.parse(sDate);
      return sDate.equals(formatter.format(date));
    } catch (Exception e) {
      return false;
    } 
  }
}
